package org.example.data.user

class UserRepositoryImpl: UserRepository {
    val usersList = mutableListOf(
        UserDTO(
            userID = 1,
            email = "email@email.ru",
            password = "qweasd"
        )
    )
    override fun add(userDTO: UserDTO): Boolean {
        return usersList.add(userDTO)
    }

    override fun updateUserByID(userID: Int, updatedUser: UserDTO): UserDTO {
        val oldUser = usersList.find { it.userID == userID }
        checkNotNull(oldUser){
            "Пользователь не найден"
        }
        if (oldUser.email != updatedUser.email && updatedUser.email.isNotEmpty()) {
            oldUser.email = updatedUser.email
        }
        if (oldUser.phone != updatedUser.phone && updatedUser.phone?.isNotEmpty() == true) {
            oldUser.phone = updatedUser.phone
        }
        oldUser.password = updatedUser.password
        oldUser.address = updatedUser.address
        oldUser.lastName = updatedUser.lastName
        return oldUser
    }

    override fun getAllUsers(): List<UserDTO> = usersList

    override fun getUserById(userID: Int): UserDTO {
        val findUser = usersList.find { it.userID == userID }
        checkNotNull(findUser){
            "Пользователь не найден"
        }
        return findUser
    }

    override fun removeUser(userID: Int): Boolean {
        return usersList.removeIf{ it.userID == userID}
    }

}