package org.example.ui.user

import org.example.data.user.UserDTO
import org.example.data.user.UserRepository

class UserUi(private val userRepository: UserRepository) {
    fun userDtoToUserPresenter(userDTO: UserDTO): UserPresenter{
        return UserPresenter(
            userID = userDTO.userID,
            email = userDTO.email,
            lastName = userDTO.lastName,
            firstName = userDTO.firstName,
            address = userDTO.address,
            phone = userDTO.phone
        )
    }
    fun printAllUser(){
        userRepository.getAllUsers().map(::userDtoToUserPresenter).forEach {
            println(it)
        }
    }
    fun addUser(){
        println("Введите почту")
        val email = readlnOrNull()
        require(!email.isNullOrEmpty()){
            "Неправильный ввод"
        }
        println("Введите пароль")
        val password = readlnOrNull()
        require(!password.isNullOrEmpty()){
            "Неправильный ввод"
        }
        val newUser = UserDTO(
            userID = userRepository.getAllUsers().size + 1,
            email = email,
            password = password
        )
        if(userRepository.add(newUser)) println("пользователь успешно добавлен\n")
    }
}